/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	Tv^[QbgˑVAIOW[iCQ7144Apj
 */

/*
 *	{UART1AISP(In system programming)ƃVAʐMŌpD
 *	̂߁A{W[ɂĂUART1VAIOɎgpD
 */

#if !defined( _HW_SERIAL_H_ )
#define _HW_SERIAL_H_


#include	"kernel.h"
#include	"sh7144.h"


/*
 *  VA|[g̊݃x`
 */
#define	CFG_INTLVL_SERIAL_RX1	(UINT16)( 0x6 )	/* VAM */

/*
 *  VA|[g̃{[[g`
 *
 *  CFG_BRR_SERIAL ̒`ύXŃ{[[gύX\
 */
#define	BRR_SERIAL_9600		(UINT8)( 77 )	/* 750000/{BRR+1} =  9615	*/
#define	BRR_SERIAL_19200	(UINT8)( 38 )	/* 750000/{BRR+1} = 19230	*/
#define	BRR_SERIAL_38400	(UINT8)( 19 )	/* 750000/{BRR+1} = 37500	*/
#define	BRR_SERIAL_57600	(UINT8)( 12 )	/* 750000/{BRR+1} = 57692	*/
#define	CFG_BRR_SERIAL		BRR_SERIAL_57600


#if !defined( _MACRO_ONLY )

/*
 *  VXeOo̓W[֐vg^Cv錾
 */
extern void	InitHwSerial( void );

/*
 *  VXeOo̓W[~֐vg^Cv錾
 */
extern void	TermHwSerial( void );

/*
 *  ĂюwReLXgł̕M֐vg^Cv錾
 */
Inline void	PutHwChar( UINT8 character );

/*
 *  R[obN֐OQ
 */
extern void	RxSerialInt( UINT8 character );

/*
 *  ĂюwReLXgł̕MD
 *
 *  {֐͊݋֎~ԂŌĂяoƁD
 *  sR[hȂǂ̐R[hvōsƁD
 */
Inline void
PutHwChar( UINT8 character )
{
	/* Mobt@ɂȂ܂ő҂	*/
	while( (SSR1 & (UINT8)0x80) == 0 ){
	}

	/* P */
	TDR1 = character;

	/* MƂ */
	SSR1 &= (UINT8)~0x80;

}	/* PutHwChar	*/

#endif /* _MACRO_ONLY */


#endif /* _HW_SERIAL_H_ */

